diff mbox series

[lttng-tools,v2] Test for lttng-logger

Message ID 1515613760-10546-1-git-send-email-jdesfossez@efficios.com
State Accepted, archived
Delegated to: Jérémie Galarneau
Headers show
Series [lttng-tools,v2] Test for lttng-logger | expand

Commit Message

Julien Desfossez Jan. 10, 2018, 7:49 p.m. UTC
Basic test to write in /proc/lttng-logger and /dev/lttng-logger and
ensure we have the right amount of events in the trace resulting trace.
We also test the 1024 characters limit for the payload.

Signed-off-by: Julien Desfossez <jdesfossez at efficios.com>
---
 tests/regression/kernel/Makefile.am       |   2 +-
 tests/regression/kernel/test_lttng_logger | 138 ++++++++++++++++++++++++++++++
 tests/root_regression                     |   1 +
 tests/utils/utils.sh                      |   2 +-
 4 files changed, 141 insertions(+), 2 deletions(-)
 create mode 100755 tests/regression/kernel/test_lttng_logger

Comments

Mathieu Desnoyers Feb. 20, 2018, 4:58 p.m. UTC | #1
----- On Jan 10, 2018, at 2:49 PM, Julien Desfossez jdesfossez at efficios.com wrote:

> Basic test to write in /proc/lttng-logger and /dev/lttng-logger and
> ensure we have the right amount of events in the trace resulting trace.
> We also test the 1024 characters limit for the payload.

I just merged the /dev/lttng-logger interface into lttng-modules. Jérémie,
can you merge this into tools master ?

Acked-by: Mathieu Desnoyers <mathieu.desnoyers at efficios.com>

Thanks,

Mathieu

> 
> Signed-off-by: Julien Desfossez <jdesfossez at efficios.com>
> ---
> tests/regression/kernel/Makefile.am       |   2 +-
> tests/regression/kernel/test_lttng_logger | 138 ++++++++++++++++++++++++++++++
> tests/root_regression                     |   1 +
> tests/utils/utils.sh                      |   2 +-
> 4 files changed, 141 insertions(+), 2 deletions(-)
> create mode 100755 tests/regression/kernel/test_lttng_logger
> 
> diff --git a/tests/regression/kernel/Makefile.am
> b/tests/regression/kernel/Makefile.am
> index c4ee443..a0abc7b 100644
> --- a/tests/regression/kernel/Makefile.am
> +++ b/tests/regression/kernel/Makefile.am
> @@ -1,6 +1,6 @@
> EXTRA_DIST = test_event_basic test_all_events test_syscall \
> 		test_clock_override test_rotation_destroy_flush \
> -		test_select_poll_epoll
> +		test_select_poll_epoll test_lttng_logger
> 
> noinst_PROGRAMS = select_poll_epoll
> select_poll_epoll_SOURCES = select_poll_epoll.c
> diff --git a/tests/regression/kernel/test_lttng_logger
> b/tests/regression/kernel/test_lttng_logger
> new file mode 100755
> index 0000000..b0a53fe
> --- /dev/null
> +++ b/tests/regression/kernel/test_lttng_logger
> @@ -0,0 +1,138 @@
> +#!/bin/bash
> +#
> +# Copyright (C) - 2017 Julien Desfossez <jdesfossez at efficios.com>
> +#
> +# This program is free software; you can redistribute it and/or modify it
> +# under the terms of the GNU General Public License, version 2 only, as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it will be useful, but WITHOUT
> +# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
> +# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
> +# more details.
> +#
> +# You should have received a copy of the GNU General Public License along with
> +# this program; if not, write to the Free Software Foundation, Inc., 51
> +# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
> +
> +TEST_DESC="Kernel tracer - lttng-logger"
> +
> +CURDIR=$(dirname $0)/
> +TESTDIR=$CURDIR/../..
> +NUM_TESTS=30
> +PAYLOAD="test_logger"
> +SESSION_NAME="kernel_event_basic"
> +
> +source $TESTDIR/utils/utils.sh
> +
> +function test_proc_logger()
> +{
> +	diag "Test /proc/lttng-logger"
> +
> +	TRACE_PATH=$(mktemp -d)
> +
> +	create_lttng_session_ok $SESSION_NAME $TRACE_PATH
> +
> +	lttng_enable_kernel_event $SESSION_NAME "lttng_logger"
> +
> +	start_lttng_tracing_ok
> +
> +	test -e /proc/lttng-logger
> +	if test $? = 0; then
> +		pass "/proc/lttng-logger exists"
> +		echo -n "$PAYLOAD proc" > /proc/lttng-logger
> +		ok $? "Write in /proc/lttng-logger"
> +	else
> +		fail "No /proc/lttng-logger"
> +	fi
> +
> +	stop_lttng_tracing_ok
> +
> +	validate_trace_count "lttng_logger" $TRACE_PATH 1
> +	validate_trace_only_exp "$PAYLOAD" $TRACE_PATH
> +
> +	destroy_lttng_session_ok $SESSION_NAME
> +
> +	rm -rf $TRACE_PATH
> +}
> +
> +function test_dev_logger()
> +{
> +	diag "Test /dev/lttng-logger"
> +
> +	TRACE_PATH=$(mktemp -d)
> +
> +	create_lttng_session_ok $SESSION_NAME $TRACE_PATH
> +
> +	lttng_enable_kernel_event $SESSION_NAME "lttng_logger"
> +
> +	start_lttng_tracing_ok
> +
> +	test -c /dev/lttng-logger
> +	if test $? = 0; then
> +		pass "/dev/lttng-logger is a character device"
> +		echo -n "$PAYLOAD dev" > /dev/lttng-logger
> +		ok $? "Write in /dev/lttng-logger"
> +	else
> +		fail "No /dev/lttng-logger"
> +	fi
> +
> +	stop_lttng_tracing_ok
> +
> +	validate_trace_count "lttng_logger" $TRACE_PATH 1
> +	validate_trace_only_exp "$PAYLOAD" $TRACE_PATH
> +
> +	destroy_lttng_session_ok $SESSION_NAME
> +
> +	rm -rf $TRACE_PATH
> +}
> +
> +function test_payload_limit()
> +{
> +	diag "Test lttng-logger payload limit"
> +
> +	TRACE_PATH=$(mktemp -d)
> +
> +	create_lttng_session_ok $SESSION_NAME $TRACE_PATH
> +
> +	lttng_enable_kernel_event $SESSION_NAME "lttng_logger"
> +
> +	start_lttng_tracing_ok
> +
> +	# Write 100 times "test_logger", which generates 1200 characters, we expect
> +	# the tracer to write 2 events from that string because it limits the
> +	# input to 1024 strings.
> +	printf "%.s $PAYLOAD" {1..100} > /proc/lttng-logger
> +	printf "%.s $PAYLOAD" {1..100} > /dev/lttng-logger
> +
> +	stop_lttng_tracing_ok
> +
> +	validate_trace_count "lttng_logger" $TRACE_PATH 4
> +	validate_trace_only_exp "$PAYLOAD" $TRACE_PATH
> +
> +	destroy_lttng_session_ok $SESSION_NAME
> +
> +	rm -rf $TRACE_PATH
> +}
> +
> +# MUST set TESTDIR before calling those functions
> +plan_tests $NUM_TESTS
> +
> +print_test_banner "$TEST_DESC"
> +
> +if [ "$(id -u)" == "0" ]; then
> +	isroot=1
> +else
> +	isroot=0
> +fi
> +
> +skip $isroot "Root access is needed. Skipping all tests." $NUM_TESTS ||
> +{
> +	start_lttng_sessiond
> +
> +	test_proc_logger
> +	test_dev_logger
> +	test_payload_limit
> +
> +	stop_lttng_sessiond
> +}
> diff --git a/tests/root_regression b/tests/root_regression
> index 7639c18..f17ac97 100644
> --- a/tests/root_regression
> +++ b/tests/root_regression
> @@ -4,6 +4,7 @@ regression/kernel/test_syscall
> regression/kernel/test_clock_override
> regression/kernel/test_rotation_destroy_flush
> regression/kernel/test_select_poll_epoll
> +regression/kernel/test_lttng_logger
> regression/tools/live/test_kernel
> regression/tools/live/test_lttng_kernel
> regression/tools/streaming/test_high_throughput_limits
> diff --git a/tests/utils/utils.sh b/tests/utils/utils.sh
> index e8dfcda..50b5db1 100644
> --- a/tests/utils/utils.sh
> +++ b/tests/utils/utils.sh
> @@ -1480,7 +1480,7 @@ function validate_trace_only_exp()
> 	local total=$($BABELTRACE_BIN $trace_path | wc -l)
> 
> 	if [ "$count" -ne 0 ] && [ "$total" -eq "$count" ]; then
> -		pass "Trace match with $total for expression '${event_exp}"
> +		pass "Trace match with $total for expression '${event_exp}'"
> 	else
> 		fail "Trace match"
> 		diag "$total syscall event(s) found, only syscalls matching expression
> 		'${event_exp}' ($count occurrences) are expected"
> --
> 2.7.4
diff mbox series

Patch

diff --git a/tests/regression/kernel/Makefile.am b/tests/regression/kernel/Makefile.am
index c4ee443..a0abc7b 100644
--- a/tests/regression/kernel/Makefile.am
+++ b/tests/regression/kernel/Makefile.am
@@ -1,6 +1,6 @@ 
 EXTRA_DIST = test_event_basic test_all_events test_syscall \
 		test_clock_override test_rotation_destroy_flush \
-		test_select_poll_epoll
+		test_select_poll_epoll test_lttng_logger
 
 noinst_PROGRAMS = select_poll_epoll
 select_poll_epoll_SOURCES = select_poll_epoll.c
diff --git a/tests/regression/kernel/test_lttng_logger b/tests/regression/kernel/test_lttng_logger
new file mode 100755
index 0000000..b0a53fe
--- /dev/null
+++ b/tests/regression/kernel/test_lttng_logger
@@ -0,0 +1,138 @@ 
+#!/bin/bash
+#
+# Copyright (C) - 2017 Julien Desfossez <jdesfossez at efficios.com>
+#
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License, version 2 only, as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+# more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 51
+# Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+TEST_DESC="Kernel tracer - lttng-logger"
+
+CURDIR=$(dirname $0)/
+TESTDIR=$CURDIR/../..
+NUM_TESTS=30
+PAYLOAD="test_logger"
+SESSION_NAME="kernel_event_basic"
+
+source $TESTDIR/utils/utils.sh
+
+function test_proc_logger()
+{
+	diag "Test /proc/lttng-logger"
+
+	TRACE_PATH=$(mktemp -d)
+
+	create_lttng_session_ok $SESSION_NAME $TRACE_PATH
+
+	lttng_enable_kernel_event $SESSION_NAME "lttng_logger"
+
+	start_lttng_tracing_ok
+
+	test -e /proc/lttng-logger
+	if test $? = 0; then
+		pass "/proc/lttng-logger exists"
+		echo -n "$PAYLOAD proc" > /proc/lttng-logger
+		ok $? "Write in /proc/lttng-logger"
+	else
+		fail "No /proc/lttng-logger"
+	fi
+
+	stop_lttng_tracing_ok
+
+	validate_trace_count "lttng_logger" $TRACE_PATH 1
+	validate_trace_only_exp "$PAYLOAD" $TRACE_PATH
+
+	destroy_lttng_session_ok $SESSION_NAME
+
+	rm -rf $TRACE_PATH
+}
+
+function test_dev_logger()
+{
+	diag "Test /dev/lttng-logger"
+
+	TRACE_PATH=$(mktemp -d)
+
+	create_lttng_session_ok $SESSION_NAME $TRACE_PATH
+
+	lttng_enable_kernel_event $SESSION_NAME "lttng_logger"
+
+	start_lttng_tracing_ok
+
+	test -c /dev/lttng-logger
+	if test $? = 0; then
+		pass "/dev/lttng-logger is a character device"
+		echo -n "$PAYLOAD dev" > /dev/lttng-logger
+		ok $? "Write in /dev/lttng-logger"
+	else
+		fail "No /dev/lttng-logger"
+	fi
+
+	stop_lttng_tracing_ok
+
+	validate_trace_count "lttng_logger" $TRACE_PATH 1
+	validate_trace_only_exp "$PAYLOAD" $TRACE_PATH
+
+	destroy_lttng_session_ok $SESSION_NAME
+
+	rm -rf $TRACE_PATH
+}
+
+function test_payload_limit()
+{
+	diag "Test lttng-logger payload limit"
+
+	TRACE_PATH=$(mktemp -d)
+
+	create_lttng_session_ok $SESSION_NAME $TRACE_PATH
+
+	lttng_enable_kernel_event $SESSION_NAME "lttng_logger"
+
+	start_lttng_tracing_ok
+
+	# Write 100 times "test_logger", which generates 1200 characters, we expect
+	# the tracer to write 2 events from that string because it limits the
+	# input to 1024 strings.
+	printf "%.s $PAYLOAD" {1..100} > /proc/lttng-logger
+	printf "%.s $PAYLOAD" {1..100} > /dev/lttng-logger
+
+	stop_lttng_tracing_ok
+
+	validate_trace_count "lttng_logger" $TRACE_PATH 4
+	validate_trace_only_exp "$PAYLOAD" $TRACE_PATH
+
+	destroy_lttng_session_ok $SESSION_NAME
+
+	rm -rf $TRACE_PATH
+}
+
+# MUST set TESTDIR before calling those functions
+plan_tests $NUM_TESTS
+
+print_test_banner "$TEST_DESC"
+
+if [ "$(id -u)" == "0" ]; then
+	isroot=1
+else
+	isroot=0
+fi
+
+skip $isroot "Root access is needed. Skipping all tests." $NUM_TESTS ||
+{
+	start_lttng_sessiond
+
+	test_proc_logger
+	test_dev_logger
+	test_payload_limit
+
+	stop_lttng_sessiond
+}
diff --git a/tests/root_regression b/tests/root_regression
index 7639c18..f17ac97 100644
--- a/tests/root_regression
+++ b/tests/root_regression
@@ -4,6 +4,7 @@  regression/kernel/test_syscall
 regression/kernel/test_clock_override
 regression/kernel/test_rotation_destroy_flush
 regression/kernel/test_select_poll_epoll
+regression/kernel/test_lttng_logger
 regression/tools/live/test_kernel
 regression/tools/live/test_lttng_kernel
 regression/tools/streaming/test_high_throughput_limits
diff --git a/tests/utils/utils.sh b/tests/utils/utils.sh
index e8dfcda..50b5db1 100644
--- a/tests/utils/utils.sh
+++ b/tests/utils/utils.sh
@@ -1480,7 +1480,7 @@  function validate_trace_only_exp()
 	local total=$($BABELTRACE_BIN $trace_path | wc -l)
 
 	if [ "$count" -ne 0 ] && [ "$total" -eq "$count" ]; then
-		pass "Trace match with $total for expression '${event_exp}"
+		pass "Trace match with $total for expression '${event_exp}'"
 	else
 		fail "Trace match"
 		diag "$total syscall event(s) found, only syscalls matching expression '${event_exp}' ($count occurrences) are expected"